#ifndef __ANCESTOR_ENUM_H
#define __ANCESTOR_ENUM_H

#include "bfc/ptrlist.h"

/*<?<autoheader/>*/
class AncestorEntry;
class Workspace;
class ClassFactoryChunk;
/*?>*/

class AncestorEntry {
public:
  AncestorEntry(ClassFactoryChunk *chunk, int scope) : m_chunk(chunk), m_scope(scope) {}
  ClassFactoryChunk *m_chunk;
  int m_scope;
};

class AncestorEnum {
public:
  AncestorEnum();
  AncestorEnum(ClassFactoryChunk *chunk, Workspace *m_workspace);
  virtual ~AncestorEnum();
  void setChunk(ClassFactoryChunk *chunk);
  void setWorkspace(Workspace *workspace);

  int findAncestor(const char *ancestorname);
  int getNumAncestors();
  AncestorEntry *enumAncestor(int n);

private:
  void enumerate();
  ClassFactoryChunk * m_chunk;
  Workspace *m_workspace;
  PtrList < AncestorEntry > m_ancestors;
};

#endif // __ANCESTOR_ENUM_H
