#ifndef __CHUNKHIERARCHY_H
#define __CHUNKHIERARCHY_H

class ClassFactoryChunk;

#include <bfc/ptrlist.h>
#include <bfc/string/string.h>

#include "ChunkList.h"

/*<?<autoheader/>*/
class ClassFactoryChunk;
class ClassFactoryMethod;
/*?>*/

class ChunkHierarchy {
  protected:
    // inherit me ! implement constructor to fill chunkLists
  ChunkHierarchy();

  public:
  virtual ~ChunkHierarchy();

  virtual void addChunk(ClassFactoryChunk *chunk, const char *curpath = NULL); // cross-recursive with addClass
  virtual void addClass(const char *classname, const char *curpath = NULL); // cross-recursive with addChunk

  virtual int getNumChunks();
  virtual ClassFactoryChunk *enumChunk(int n);
  virtual const char *enumPath(int n);

  virtual void reset();

    // fill these with your custom constructor !
    PtrListInsertSorted<ClassFactoryChunk, ClassFactoryChunkSortInterface> chunkListInt;
    PtrListInsertSorted<ClassFactoryChunk, ClassFactoryChunkSortImplementation> chunkListImp;

  virtual void onClassNotFound(const char *classname, const char *hierarchypath);

  virtual ClassFactoryMethod *findMethod(const char *methodname, String &ancestorpath, int casesensitive = 0, ClassFactoryChunk **ptr_chunk = NULL, int mustbeimplemented = 0, int findbasechunk = 1); // finds the last overrider method in the hierarchy. 
  virtual ClassFactoryMethod *findOriginalMethod(const char *methodname, String &ancestorpath, int casesensitive = 0, ClassFactoryChunk **ptr_chunk = NULL, int mustbeimplemented = 0, int findbasechunk = 1); // finds the first defined method in the hierarchy. 

  private:
    ChunkList m_chunks;
    int m_maxlevel;
};

#endif
