#ifndef __CLASSFACTORYBLOCKI_H
#define __CLASSFACTORYBLOCKI_H

/*[interface.header.h]
class XmlReaderParams;

enum {
  CF_BLOCKTYPE_UNDEFINED,
  CF_BLOCKTYPE_METHOD,
  CF_BLOCKTYPE_CODEBLOCK,
  CF_BLOCKTYPE_DATA,
  CF_BLOCKTYPE_SUBCHUNK,
};
*/

/*<?<autoheader/>*/
#include "ClassFactoryBlock.h"
#include "ClassFactoryBlockX.h"

class ClassFactoryBlock;
class ClassFactoryChunk;
class ClassFactoryCodeBlock;
class ClassFactoryCodeBlockI;
class ClassFactoryData;
class ClassFactoryDataI;
class ClassFactoryMethod;
class ClassFactoryMethodI;
class ClassFactorySubChunk;
class ClassFactorySubChunkI;
/*?>*/

class ClassFactoryMethodI;
class ClassFactoryCodeBlockI;
class ClassFactoryDataI;

#include "FlagHolder.h"

class ClassFactoryBlockI : public ClassFactoryBlockX, public FlagHolder {
public:
  ClassFactoryBlockI();
  ClassFactoryBlockI(ClassFactoryMethod *m);
  ClassFactoryBlockI(ClassFactoryCodeBlock *cb);
  ClassFactoryBlockI(ClassFactoryData *data);
  ClassFactoryBlockI(ClassFactorySubChunk *subchunk);
  virtual ~ClassFactoryBlockI();
  DISPATCH(50) virtual void copy(ClassFactoryBlock *block);
  DISPATCH(60) virtual int getBlockType();
  DISPATCH(70) virtual ClassFactoryMethod *getMethod();
  DISPATCH(140) virtual ClassFactoryData *getData();
  DISPATCH(80) virtual ClassFactoryCodeBlock *getCodeBlock();
  DISPATCH(10) virtual ClassFactorySubChunk *getSubChunk();
  DISPATCH(20) virtual void setSubChunk(ClassFactorySubChunk *chunk);
  DISPATCH(90) virtual void setCodeBlock(ClassFactoryCodeBlock *block);
  DISPATCH(100) virtual void setMethod(ClassFactoryMethod *m);
  DISPATCH(150) virtual void setData(ClassFactoryData *data);
  DISPATCH(110) virtual void setFlag(int flag);
  DISPATCH(120) virtual int isFlagSet(int flag);
  DISPATCH(130) virtual void clearFlag(int flag);
  DISPATCH(160) virtual int getStartLine();
  DISPATCH(170) virtual int getNumLines();
  DISPATCH(180) virtual void setStartLine(int start);
  DISPATCH(190) virtual void setNumLines(int num);
  DISPATCH(200) virtual void setParentChunk(ClassFactoryChunk *chunk);
  DISPATCH(210) virtual ClassFactoryChunk *getParentChunk();
    
private:
  ClassFactoryMethodI *method;
  ClassFactoryCodeBlockI *codeblock;
  ClassFactoryDataI *m_data;
  ClassFactorySubChunkI *m_subchunk;
  ClassFactoryChunk *m_chunk;
  int m_startline;
  int m_numlines;
};

#endif // __CLASSFACTORYBLOCKI_H
