#include "precomp.h"
#include "ClassFactoryCodeBlockI.h"

ClassFactoryCodeBlockI::ClassFactoryCodeBlockI() { 
}

ClassFactoryCodeBlockI::ClassFactoryCodeBlockI(const char *text, const char *_type) { 
  txt = text; 
  params.removeItem("type"); 
  params.addItem("type", _type); 
  processText(); 
}

ClassFactoryCodeBlockI::~ClassFactoryCodeBlockI() { 
}

const char *ClassFactoryCodeBlockI::getCodeBlock() { 
  return txt; 
}

const char *ClassFactoryCodeBlockI::getType() { 
  return params.getItemValue2("type"); 
}

void ClassFactoryCodeBlockI::setType(const char *type) {
  params.removeItem("type"); 
  params.addItem("type", type); 
}

void ClassFactoryCodeBlockI::setCodeBlock(const char *text, const char *type) { 
  txt = text; 
  String t = type; 
  params.removeItem("type"); 
  params.addItem("type", t); 
  processText(); 
}

XmlReaderParams *ClassFactoryCodeBlockI::getParams() { 
  return &params; 
}

void ClassFactoryCodeBlockI::setParams(XmlReaderParams *_params) {
  for (int i=0;i<_params->getNbItems();i++)
    params.addItem(_params->getItemName(i), _params->getItemValue(i));
}

void ClassFactoryCodeBlockI::setFlag(int flag) { 
  flag_setFlag(flag); 
}

int ClassFactoryCodeBlockI::isFlagSet(int flag) { 
  return flag_isFlagSet(flag); 
}

void ClassFactoryCodeBlockI::clearFlag(int flag) { 
  flag_clearFlag(flag); 
}

void ClassFactoryCodeBlockI::copy(ClassFactoryCodeBlock *b) {
  while (params.getNbItems()) params.removeItem(params.getItemName(0));
  XmlReaderParams *par = b->getParams();
  int p, np = par->getNbItems();
  for (p=0;p<np;p++) {
    params.addItem(par->getItemName(p), par->getItemValue(p));
  }
  flag_copy(static_cast<ClassFactoryCodeBlockI *>(b));
  setCodeBlock(b->getCodeBlock(), b->getType());
}

void ClassFactoryCodeBlockI::processText() {
  if (txt.isempty()) return;
  char *str = (char *)MALLOC(STRLEN(txt)+1);
  char *d = str;
  char *p = txt.getNonConstVal();
  char *start = p;
  while (*p) {
    if (*p == '\r' && *(p+1) == '\n') { p++; }
    *d = *p;
    p++; d++;
  }
  *d = 0;
  d = str;
  while (*d) {
    if (!STRNCMP(d, "\x3C\x23\x5B\x43\x44\x41\x54\x41", 8))
      *(d+1) = '!';
    if (!STRNCMP(d, "\x5D\x23\x3E", 3))
      *(d+1) = ']';
    d++;
  }
  txt = str;
  FREE(str);
}
