#ifndef __CLASSFACTORYCODEBLOCKI_H
#define __CLASSFACTORYCODEBLOCKI_H

#include <bfc/string/string.h>
#include <api/xml/xmlparamsi.h>
#include "FlagHolder.h"

/*<?<autoheader/>*/
#include "ClassFactoryCodeBlock.h"
#include "ClassFactoryCodeBlockX.h"

class ClassFactoryCodeBlock;
/*?>*/

/*[interface.header.h]
class XmlReaderParams;
*/

class ClassFactoryCodeBlockI : public ClassFactoryCodeBlockX, public FlagHolder {
public:
  NODISPATCH ClassFactoryCodeBlockI();
  NODISPATCH ClassFactoryCodeBlockI(const char *text, const char *_type);
  NODISPATCH virtual ~ClassFactoryCodeBlockI();
  DISPATCH(40) virtual const char *getCodeBlock();
  DISPATCH(50) virtual const char *getType();
  DISPATCH(60) virtual void setType(const char *type);
  DISPATCH(70) virtual void setCodeBlock(const char *text, const char *type);
  DISPATCH(80) virtual XmlReaderParams *getParams();
  DISPATCH(90) virtual void setParams(XmlReaderParams *_params);
  DISPATCH(100) virtual void setFlag(int flag);
  DISPATCH(110) virtual int isFlagSet(int flag);
  DISPATCH(120) virtual void clearFlag(int flag);
  DISPATCH(130) virtual void copy(ClassFactoryCodeBlock *b);

private:
  NODISPATCH virtual void processText();
  String txt;
  XmlReaderParamsI params;
};

#endif // __CLASSFACTORYCODEBLOCKI_H
