#ifndef __CLASSFACTORYDATAI_H
#define __CLASSFACTORYDATAI_H

/*<?<autoheader/>*/
#include "ClassFactoryData.h"
#include "ClassFactoryDataX.h"

class ClassFactoryBlock;
class ClassFactoryData;
/*?>*/

/*[interface.header.h]
class XmlReaderParams;
*/

#include <bfc/string/string.h>
#include <api/xml/xmlparamsi.h>
#include "FlagHolder.h"

class ClassFactoryDataI : public ClassFactoryDataX, public FlagHolder {
public:
  ClassFactoryDataI();
  ClassFactoryDataI(const char *name, const char *type);
  virtual ~ClassFactoryDataI();
  DISPATCH(10) virtual void copy(ClassFactoryData *data);
  DISPATCH(20) virtual const char *getName();
  DISPATCH(30) virtual void setName(const char *name);
  DISPATCH(40) virtual void setDataType(const char *type);
  DISPATCH(50) virtual const char *getDataType();
  DISPATCH(60) virtual void setInitValue(const char *val);
  DISPATCH(70) virtual const char *getInitValue();
  DISPATCH(80) virtual void setCtorCode(const char *code);
  DISPATCH(90) virtual void setDtorCode(const char *code);
  DISPATCH(100) virtual const char *getCtorCode();
  DISPATCH(110) virtual const char *getDtorCode();
  DISPATCH(120) virtual void setParentBlock(ClassFactoryBlock *block);
  DISPATCH(130) virtual ClassFactoryBlock *getParentBlock();
  DISPATCH(140) virtual void setScope(int s);
  DISPATCH(150) virtual int getScope();
  DISPATCH(160) virtual XmlReaderParams *getParams();
  DISPATCH(170) virtual void setParams(XmlReaderParams *_params);
  DISPATCH(180) virtual void setClassName(const char *name);
  DISPATCH(190) virtual const char *getClassName();
  DISPATCH(200) virtual void setFlag(int flag);
  DISPATCH(210) virtual int isFlagSet(int flag);
  DISPATCH(220) virtual void clearFlag(int flag);
  DISPATCH(230) virtual int isStatic();
  DISPATCH(240) virtual void setStatic(int is);
  DISPATCH(250) virtual void setSourceLine(int sl);
  DISPATCH(260) virtual int getSourceLine();

private:
  String m_classname;
  String m_type;
  String m_name;
  String m_ctorcode;
  String m_dtorcode;
  ClassFactoryBlock * m_parent;
  XmlReaderParamsI xparams;
  int m_sourceline;
};

#endif // __CLASSFACTORYDATAI_H
