#ifndef __CLASSFACTORYMETHODI_H
#define __CLASSFACTORYMETHODI_H

/*[interface.header.h]
#ifndef NULL
#define NULL 0
#endif

class XmlReaderParams;

enum {
  SCOPE_NEUTRAL=-1,
  SCOPE_PUBLIC=0,
  SCOPE_PRIVATE=1,
  SCOPE_PROTECTED=2,
};
*/

/*<?<autoheader/>*/
#include "ClassFactoryMethod.h"
#include "ClassFactoryMethodX.h"

class ClassFactoryBlock;
class ClassFactoryCodeBlock;
class ClassFactoryMethod;
class ClassFactoryParam;
class HelpSection;
/*?>*/

#include "ClassFactoryCodeBlockI.h"
#include "ClassFactoryParamI.h"
#include "HelpSectionI.h"
#include "FlagHolder.h"

#include <bfc/string/string.h>
#include <bfc/ptrlist.h>
#include <api/xml/xmlparams.h>

class ClassFactoryMethodI : public ClassFactoryMethodX, public FlagHolder {
public:
  ClassFactoryMethodI(const char *_name = NULL, const char *_rettype = NULL, const char *_defret = NULL);
  virtual ~ClassFactoryMethodI();
  DISPATCH(30) virtual void copy(ClassFactoryMethod *m);
  DISPATCH(40) virtual const char *getName();
  DISPATCH(50) virtual const char *getReturnType();
  DISPATCH(60) virtual const char *getDefaultReturnValue();
  DISPATCH(70) virtual int getNumParams();
  DISPATCH(80) virtual ClassFactoryParam *enumParam(int n);
  DISPATCH(90) virtual void addParam(ClassFactoryParam *p);
  DISPATCH(100) virtual void setName(const char *_name);
  DISPATCH(110) virtual void setReturnType(const char *_rettype);
  DISPATCH(120) virtual void setDefaultReturnValue(const char *_defret);
  DISPATCH(130) virtual XmlReaderParams *getParams();
  DISPATCH(140) virtual void setParams(XmlReaderParams *_params);
  DISPATCH(150) virtual void dropCodeBlocks(const char *type);
  DISPATCH(160) virtual void setCodeBlock(ClassFactoryCodeBlock *cb);
  DISPATCH(170) virtual ClassFactoryCodeBlock *getCodeBlock(const char *type);
  DISPATCH(180) virtual void setFlag(int flag);
  DISPATCH(190) virtual int isFlagSet(int flag);
  DISPATCH(200) virtual void clearFlag(int flag);
  DISPATCH(210) virtual void setClassName(const char *name);
  DISPATCH(220) virtual const char *getClassName();
  DISPATCH(230) virtual void setHeader(const char *header, const char *type);
  DISPATCH(240) virtual void setFooter(const char *footer, const char *type);
  DISPATCH(450) virtual void setPostDeclModifier(const char *postdeclmodifier);
  DISPATCH(460) virtual const char *getPostDeclModifier();
  DISPATCH(250) virtual const char *getHeader(const char *type);
  DISPATCH(260) virtual const char *getFooter(const char *type);
  DISPATCH(270) virtual void setStatic(int s);
  DISPATCH(280) virtual int isStatic();
  DISPATCH(290) virtual void setScope(int s);
  DISPATCH(300) virtual int getScope();
  DISPATCH(310) virtual void setInline(int s, int where);
  DISPATCH(320) virtual int isInline(int *where = NULL);
  DISPATCH(330) virtual void setVirtual(int v, int pure);
  DISPATCH(340) virtual int isVirtual(int *pure = NULL);
  DISPATCH(350) virtual void addHelpSection(HelpSection *section);
  DISPATCH(360) virtual int getNumHelpSections();
  DISPATCH(370) virtual HelpSection *enumHelpSection(int n);
  DISPATCH(380) virtual void deleteHelpSection(HelpSection *s);
  DISPATCH(390) virtual void setParentBlock(ClassFactoryBlock *block);
  DISPATCH(400) virtual ClassFactoryBlock *getParentBlock();
  DISPATCH(410) virtual int getStartLine(const char *type);
  DISPATCH(420) virtual int getNumLines(const char *type);
  DISPATCH(430) virtual void setStartLine(int n, const char *type);
  DISPATCH(440) virtual void setNumLines(int n, const char *type);
  DISPATCH(470) virtual int isConstructor();
  DISPATCH(480) virtual int isDestructor();
  DISPATCH(490) virtual void setSourceLine(int sl);
  DISPATCH(500) virtual int getSourceLine();

private:
  XmlReaderParamsI xparams;
  String name;
  String rettype;
  String defret;
  PtrList < ClassFactoryParamI > params;
  PtrList < ClassFactoryCodeBlockI > codeblocks;
  PtrList < ClassFactoryCodeBlockI > headers;
  PtrList < ClassFactoryCodeBlockI > footers;
  PtrList < HelpSectionI > m_helpsections;
  String classname;
  ClassFactoryBlock * parentblock;
  int ln_hstart;
  int ln_cppstart;
  int ln_inlinestart;
  int ln_hnum;
  int ln_cppnum;
  int ln_inlinenum;
  int m_sourceline;
};

class ClassFactoryMethodSort {
  public:
    static int compareItem(ClassFactoryMethod *p1, ClassFactoryMethod *p2) {
      return STRICMP(p1->getName(), p2->getName());
    }
    static int compareAttrib(const char *attrib, ClassFactoryMethod *item) {
      return STRICMP(attrib, item->getName());
    }
};

#endif // __CLASSFACTORYMETHODI_H
