#include "precomp.h"
#include "ClassFactoryParamI.h"

ClassFactoryParamI::ClassFactoryParamI(const char *_name, const char *__type, const char *_defval) : name(_name), _type(__type), defval(_defval) { 
}

ClassFactoryParamI::~ClassFactoryParamI() {
}

void ClassFactoryParamI::copy(ClassFactoryParam *cparm) {
  while (params.getNbItems()) params.removeItem(params.getItemName(0));
  XmlReaderParams *par = cparm->getParams();
  int p, np = par->getNbItems();
  for (p=0;p<np;p++) {
    params.addItem(par->getItemName(p), par->getItemValue(p));
  }
  flag_copy(static_cast<ClassFactoryParamI*>(cparm));
  setName(cparm->getName());
  setType(cparm->getType());
  setDefaultValue(cparm->getDefaultValue());
}

const char *ClassFactoryParamI::getName() { 
  return name; 
}

const char *ClassFactoryParamI::getType() { 
  return _type; 
}

const char *ClassFactoryParamI::getDefaultValue() { 
  return defval; 
}

void ClassFactoryParamI::setName(const char *_name) { 
  name = _name; 
}

void ClassFactoryParamI::setType(const char *__type) { 
  _type = __type; 
}

void ClassFactoryParamI::setDefaultValue(const char *_defval) { 
  defval = _defval; 
}
  
XmlReaderParams *ClassFactoryParamI::getParams() { 
  return &params; 
}
 
void ClassFactoryParamI::setParams(XmlReaderParams *_params) {
  for (int i=0;i<_params->getNbItems();i++) {
    const char *par = _params->getItemName(i);
    if (STRCASEEQL(par, "name")) continue;
    if (STRCASEEQL(par, "type")) continue;
    if (STRCASEEQL(par, "default")) continue;
    params.addItem(_params->getItemName(i), _params->getItemValue(i));
  }
}

void ClassFactoryParamI::setFlag(int flag) {
  flag_setFlag(flag); 
}

int ClassFactoryParamI::isFlagSet(int flag) { 
  return flag_isFlagSet(flag); 
}

void ClassFactoryParamI::clearFlag(int flag) { 
  flag_clearFlag(flag); 
}

void ClassFactoryParamI::addHelpSection(HelpSection *section) {
  m_helpsections.addItem(static_cast<HelpSectionI*>(section));
}

int ClassFactoryParamI::getNumHelpSections() {
  return m_helpsections.getNumItems();
}

HelpSection *ClassFactoryParamI::enumHelpSection(int n) {
  return m_helpsections.enumItem(n);
}

void ClassFactoryParamI::deleteHelpSection(HelpSection *s) {
  m_helpsections.removeItem(static_cast<HelpSectionI*>(s));
  delete static_cast<HelpSectionI*>(s);
}

int ClassFactoryParamI::getInOut() {
  const char *p = params.getItemValue("io");
  if (STRCASEEQLSAFE(p, "IN")) return IO_IN;
  if (STRCASEEQLSAFE(p, "OUT")) return IO_OUT;
  if (STRCASEEQLSAFE(p, "INOUT")) return IO_INOUT;
  return 0;
}

void ClassFactoryParamI::setInOut(int inout) {
  params.removeItem("io");
  if (inout == IO_IN) params.addItem("io", "IN");
  if (inout == IO_OUT) params.addItem("io", "OUT");
  if (inout == IO_INOUT) params.addItem("io", "INOUT");
}
