#ifndef __CLASSFACTORYPARAMI_H
#define __CLASSFACTORYPARAMI_H

/*<?<autoheader/>*/
#include "ClassFactoryParam.h"
#include "ClassFactoryParamX.h"

class ClassFactoryParam;
class HelpSection;
/*?>*/

/*[interface.header.h]
class XmlReaderParams;
*/

#include "HelpSectionI.h"
#include "FlagHolder.h"

#include <bfc/string/string.h>
#include <api/xml/xmlparamsi.h>

#define IO_IN    1
#define IO_OUT   2
#define IO_INOUT (IO_IN|IO_OUT)

class ClassFactoryParamI : public ClassFactoryParamX, public FlagHolder {
public:
  ClassFactoryParamI(const char *_name = NULL, const char *__type = NULL, const char *_defval = NULL);
  virtual ~ClassFactoryParamI();
  DISPATCH(30) virtual void copy(ClassFactoryParam *cparm);
  DISPATCH(40) virtual const char *getName();
  DISPATCH(50) virtual const char *getType();
  DISPATCH(60) virtual const char *getDefaultValue();
  DISPATCH(70) virtual void setName(const char *_name);
  DISPATCH(80) virtual void setType(const char *__type);
  DISPATCH(90) virtual void setDefaultValue(const char *_defval);
  DISPATCH(100) virtual XmlReaderParams *getParams();
  DISPATCH(110) virtual void setParams(XmlReaderParams *_params);
  DISPATCH(120) virtual void setFlag(int flag);
  DISPATCH(130) virtual int isFlagSet(int flag);
  DISPATCH(140) virtual void clearFlag(int flag);
  DISPATCH(150) virtual void addHelpSection(HelpSection *section);
  DISPATCH(160) virtual int getNumHelpSections();
  DISPATCH(170) virtual HelpSection *enumHelpSection(int n);
  DISPATCH(180) virtual void deleteHelpSection(HelpSection *s);
  DISPATCH(190) virtual int getInOut();
  DISPATCH(200) virtual void setInOut(int inout);

private:
  String name;
  String _type;
  String defval;
  XmlReaderParamsI params;
  PtrList < HelpSectionI > m_helpsections;
};

#endif // __CLASSFACTORYPARAMI_H
