#ifndef __FACTORYPARSER_H
#define __FACTORYPARSER_H

/*<?<autoheader/>*/
class ClassFactoryChunk;
/*?>*/

#include <bfc/string/string.h>

class CPPParser {
  public:
  CPPParser(const char *s, char sep=' ');
  virtual ~CPPParser();

  int getNumItems();
  const char *enumItem(int n);

  private:
    PtrList<String> m_strings;
};

class ClassFactoryParser {
  public:
  static ClassFactoryChunk *parse(const char *text, ClassFactoryChunk *chunk);
  static void release(ClassFactoryChunk *chunk);
  static int getLine(const char *text, char *str, int maxlen, int *pos);
  static int isEmpty(const char *str);
  static const char *eatCR(const char *p, int *pos = NULL);
  static void reduceSpaces(char *_p);
  static void trimSpaces(String &_p);
  static int parseTypeDecl(const char *txt, const char **t, const char **m, const char **c, const char *what =  "C", const char *line =  "?", const char *deftype = NULL, int *inout=NULL);
  static void formatCPP(const char *s, int maxlen);
  static int isOneOf(char c, const char *list);
  static int isIdentifierChar(char c);
  static void eatComments(const char *str);
  static void CRToSpace(const char *str);
  static void fixupType(String &str);
  static String typedecl_name;
  static String typedecl_type;
  static String typedecl_class;
  static String errorstr;
  static void grabInOut(String &str, int *in, int *out, int *inout);
  static void grabWord(String &str, const char *word, int *var, int multiple=1);
};

#endif
