#include "precomp.h"
#include "FlagHolder.h"

FlagHolder::FlagHolder() {
}

FlagHolder::~FlagHolder() {
}

void FlagHolder::flag_copy(FlagHolder *fh) {
  flag_clearAllFlags(-1);
  int i, n = fh->flags.getNumItems();
  for (i=0;i<n;i++) {
    flags.addItem(fh->flags.enumItem(i));
  }
}

void FlagHolder::flag_setFlag(int flag, int type) {
  for (int i=0;i<flags.getNumItems();i++) {
    Pair<int,int> c = flags.enumItem(i);
    if (c.a == flag && (type == -1 || c.b == type)) return;
  }
  Pair<int,int> d(flag, type);
  flags.addItem(d);
}

int FlagHolder::flag_isFlagSet(int flag, int type) {
  for (int i=0;i<flags.getNumItems();i++) {
    Pair<int,int> c = flags.enumItem(i);
    if (c.a == flag && (type == -1 || c.b == type)) return 1;
  }
  return 0;
}

void FlagHolder::flag_clearFlag(int flag, int type) {
  for (int i=0;i<flags.getNumItems();i++) {
    Pair<int,int> c = flags.enumItem(i);
    if ((flag == -1 || c.a == flag) && (type == -1 || c.b == type)) {
      flags.delByPos(i);
      i--;
      continue;
    }
  }
}


void FlagHolder::flag_clearAllFlags(int type) {
  if (type == -1) {
    flags.removeAll();
    return;
  }
  int i, n = flags.getNumItems();
  for (i=0;i<n;i++) {
    if (flags.enumItem(i).b == type) {
      flags.delByPos(i);
      i--;
      n--;
    }
  }
}

