#include "precomp.h"
#include "HelpSectionI.h"
#include "HelpElementI.h"

HelpSectionI::HelpSectionI() {
}

HelpSectionI::~HelpSectionI() {
  m_elements.deleteAll();
}

int HelpSectionI::getNumElements() {
  return m_elements.getNumItems();
}

HelpElement *HelpSectionI::getElement(int n) {
  return m_elements.enumItem(n);
}

const char *HelpSectionI::getName() {
  return m_name;
}

void HelpSectionI::setName(const char *name) {
  m_name = name;
}

void HelpSectionI::addElement(HelpElement *element) {
  m_elements.addItem(static_cast<HelpElementI*>(element));
}

HelpElement *HelpSectionI::createElement() {
  return new HelpElementI();
}

void HelpSectionI::deleteElement(HelpElement *element) {
  m_elements.removeItem(static_cast<HelpElementI*>(element));
  delete static_cast<HelpElementI*>(element);
}

void HelpSectionI::clone(HelpSection *section) {
  m_elements.deleteAll();
  int i, n = section->getNumElements();
  for (i=0;i<n;i++) {
    HelpElementI *e = new HelpElementI();
    e->clone(section->getElement(i));
  }
  m_name = section->getName();
}
