#include "precomp.h"
#include "ImplFileEnum.h"

#include <api/xml/xmlparams.h>
#include "ClassFactoryChunk.h"


ImplFileEnum::ImplFileEnum() {
  m_chunk = NULL;
}

ImplFileEnum::ImplFileEnum(ClassFactoryChunk *chunk) {
  m_chunk = chunk;
  makeupFiles();
}

ImplFileEnum::~ImplFileEnum() {
  m_files.deleteAll();
}

void ImplFileEnum::setChunk(ClassFactoryChunk *chunk) {
  m_chunk = chunk;
  makeupFiles();
}

int ImplFileEnum::getNumFiles() {
  return m_files.getNumItems();
}

const char *ImplFileEnum::enumFile(int n) {
  return m_files.enumItem(n)->getValue();
}

void ImplFileEnum::makeupFiles() {
  ASSERT(m_chunk != NULL);
  XmlReaderParams *par = m_chunk->getParams();

  m_files.deleteAll();

  if (par == NULL) return;

  String headerName = par->getItemValue("class_header");
  if (headerName.isempty()) {
    headerName = String(m_chunk->getImplementationName()) + ".h";
    par->removeItem("class_header");
    par->addItem("class_header", headerName);
  }
  m_files.addItem(new String(headerName));

  String moduleName = par->getItemValue("class_module");
  if (moduleName.isempty()) {
    moduleName = String(m_chunk->getImplementationName()) + ".cpp";
    par->removeItem("class_module");
    par->addItem("class_module", moduleName);
  }
  m_files.addItem(new String(moduleName));
}
