#ifndef __PROJECT_H
#define __PROJECT_H

class ClassFactoryChunk;
class ProjectFile;
class String;
class Workspace;
class CastMgr;
class TypeMapMgr;

class ProjectFile {
  public:
    virtual const char *getFilename()=0;
    virtual const char *getTargetDir()=0;
    virtual const char *getProjectFolder()=0;
};

class ProgressCallback {
  public:
    virtual void setPercent(int p)=0;
    virtual void setRange(int r)=0;
    virtual void setText(const char *text)=0;
};

extern Workspace *g_workspace;
extern CastMgr *g_casts;
extern TypeMapMgr *g_typeMaps;
extern String *g_workspaceName;

extern void xpp_errorMessage(const char *filename, int fileline, const char *incpath, int errcode, const char *errstr);
extern void xpp_warningMessage(const char *filename, int fileline, const char *incpath, int errcode, const char *errstr);
extern void xpp_updateProgress(int forceupdate=0);

#endif // __PROJECT_H

