#ifndef __XHDPROCESSOR_H
#define __XHDPROCESSOR_H

#include <bfc/ptrlist.h>
#include <bfc/string/string.h>

/*<?<autoheader/>*/
class Workspace;
class ClassFactoryChunk;
class ImplementationFactory;
class ProcessorEntry;
class ProgressCallback;
class svc_srcClassFactory;
/*?>*/

class ImplementationFactory;

class ProcessorEntry {
public:
  ProcessorEntry() {
    m_svc = NULL;  
    m_releaseservice = 1;
    m_needfriend = 0;
  }
  virtual ~ProcessorEntry() { 
    if (m_svc != NULL && m_releaseservice)
      WASABI_API_SVC->service_release(m_svc);
    m_files.deleteAll(); 
  }
  svc_srcClassFactory *m_svc;
  String m_classname;
  String m_format;
  PtrList<String> m_files;
  int m_releaseservice;
  int m_needfriend;
};

class XHDProcessor {
public:
  XHDProcessor(int full, ClassFactoryChunk *chunk, const char *stopfactory = NULL, int forcestartcpp = 0, int forcestarth = 0, ProgressCallback *percent = NULL);
  virtual ~XHDProcessor();

  virtual svc_srcClassFactory *getFactory(const char *name);
  virtual ProcessorEntry *getFactoryEntry(const char *name);
  virtual int getNumFactories();
  virtual svc_srcClassFactory *enumFactory(int n);
  virtual ProcessorEntry *enumProcessorEntry(int n);

private:
  PtrList < ProcessorEntry > m_layers;
  ProgressCallback * m_ppercent;
  Workspace *m_workspace;
  ImplementationFactory * m_fact;
  String m_prevancestor;
  int m_full;
  ClassFactoryChunk * m_chunk;
};

#endif
