#ifndef __XMLTOXHD_H
#define __XMLTOXHD_H

#include "../inputfactories/XPPXmlReaderI.h"

#include "../classhierarchy/ClassFactoryChunkI.h"
#include "../classhierarchy/ClassFactoryParamI.h"
#include "../classhierarchy/ClassFactoryMethodI.h"
#include "../classhierarchy/ClassFactoryBlockI.h"
#include "../classhierarchy/ClassFactoryCodeBlockI.h"

#include "../classhierarchy/ClassFactoryParser.h"
//#include "XmlVariable.h"
#include "../outputfactories/GlobalStrings.h"

#define BUFMAX 16384

/*<?<autoheader/>*/
class ClassFactoryChunk;
class ClassFactoryChunkI;
class ClassFactoryCodeBlockI;
class ClassFactoryDataI;
class ClassFactoryMethodI;
class ClassFactoryParamI;
class HelpElementI;
class HelpSectionI;
/*?>*/

class XMLToChunk : public XPP_XmlReaderCallbackI {
public:
  XMLToChunk();
  XMLToChunk(const char *file);
  virtual ~XMLToChunk();

  virtual ClassFactoryChunk *enumChunk(int n);
  virtual int getNumChunks();

  virtual void xmlReaderOnStartElementCallback(const char *xmlpath, const char *xmltag, XmlReaderParams *params);
  virtual void xmlReaderOnEndElementCallback(const char *xmlpath, const char *xmltag);
  virtual void xmlReaderOnCharacterDataCallback(const char *xmlpath, const char *xmltag, const char *str);

  virtual const char *processVariables(const char *str);
  virtual void deleteChunk(ClassFactoryChunk *chunk);

private:
  PtrList < ClassFactoryChunkI > chunks;
  ClassFactoryChunkI *curChunk;
  ClassFactoryMethodI *curMethod;
  ClassFactoryDataI *curData;
  ClassFactoryParamI *curParam;
  ClassFactoryCodeBlockI *curCodeBlock;
  HelpSectionI *curHelpSection;
  HelpElementI *curHelpElement;
  //PtrListQuickSorted < XMLVariable, SortXMLVariable > vars;
  char varbuf[BUFMAX];
  int ifdefedout;
  int cbcount;
  int header;
  int footer;
  Stack < int > ifdefstack;
  ClassFactoryChunkI *nextChunk;
  ClassFactoryChunk *lastChunk;
};

extern int g_noVar;

#endif
