#ifndef __CPPTOXHDMERGE_H
#define __CPPTOXHDMERGE_H

#include <bfc/string/string.h>
#include <bfc/string/bigstring.h>
#include "Vfs.h"
#include "OutputFactoryBase.h"

/*<?<autoheader/>*/
class Workspace;
class ClassFactoryChunk;
class ProgressCallback;
/*?>*/

class Ancestor {
public:
  Ancestor(const char *name, int sc) : classname(name), scope(sc) {}
  String classname;
  int scope;
};

class CPPToXHDMerge {
public:
  
  CPPToXHDMerge(ClassFactoryChunk *_chunk, const char *path, int import = 0, const char *_importorigclassname = NULL, const char *_importimplclassname = NULL, ProgressCallback *percent = NULL, Workspace *workspace = NULL);
  CPPToXHDMerge(ClassFactoryChunk *_chunk, const char *_cppdata, const char *_hdata, int import = 0, const char *_importorigclassname = NULL, const char *_importimplclassname = NULL, ProgressCallback *percent = NULL, Workspace *workspace = NULL);
  virtual ~CPPToXHDMerge() { }

  virtual void setIsImport(int import);

  static void Vfgets_cpp(char *dest, int n, VFILE *fl, const char *search = NULL, int *scopemodifier = NULL, int *_bracecount = NULL, int *_bracketcount = NULL, int *linecount=NULL);
  static char *STRSTR_cpp(const char *str, const char *srch);
  static char *STRCHR_cpp(const char *str, char c);
  static void parseScope(const char *str, int *modifier);
  static void updateScope(const char *str, int *curscope);
  static int countBraces(const char *str);

private:
  void merge();
  int startsWith(const char *str, const char *with);
  char *findEndOfPar(const char *line);

  ClassFactoryChunk * chunk;
  String mergecpp;
  String mergeh;
  BigString dumbcode;
  int mergefiles;
  int isimport;
  String lastimport;
  String importorigclassname;
  String importimplclassname;
  ProgressCallback * m_ppercent;
  Workspace * m_workspace;
};

#endif
