#ifndef __FACTORYMODULE_H
#define __FACTORYMODULE_H

#include "FactoryModule.h"
#include <bfc/string/string.h>

/*<?<autoheader/>*/
class FactoryTemplate;
/*?>*/

class TemplatizedFactory;

class FactoryModule {
public:
  FactoryModule();
  virtual ~FactoryModule();
  virtual const char *getName();
  virtual const char *getData();
  virtual void setName(const char *name);
  virtual void setData(const char *data);
  virtual void setId(const char *id);
  virtual const char *getId();
  virtual void setSubModuleOf(FactoryTemplate *tmpl);
  virtual FactoryTemplate *getTemplate();
  virtual int getStartPos();
  virtual void setStartPos(int p); 

private:
  String m_modulename;
  String m_id;
  String m_moduledata;
  FactoryTemplate * m_template;
  int m_startpos;
};

#endif // __FACTORYMODULE_H
