#ifndef __FACTORYTEMPLATE_H
#define __FACTORYTEMPLATE_H

#include <bfc/ptrlist.h>
#include <bfc/string/string.h>

#include "TemplateChunk.h"

/*<?<autoheader/>*/
class TemplateChunk;
class TemplatizedFactory;
class ClassFactoryChunk;
/*?>*/

class VarSet {
public:
  VarSet(const char *_id, int _ispersistant, ClassFactoryChunk *chunk) : id(_id), ispersistant(_ispersistant), m_chunk(chunk) {}
  virtual ~VarSet() {}
  String id;
  int ispersistant;
  ClassFactoryChunk *m_chunk;
};

class FactoryTemplate {
public:
  FactoryTemplate(TemplatizedFactory *parent, const char *format);
  virtual ~FactoryTemplate();
  virtual const char *getFormat();
  virtual const char *getDescription();
  virtual void setDescription(const char *desc);
  virtual TemplateChunk *enumChunk(int n);
  virtual int getNumChunks();
  virtual void addChunk(TemplateChunk *chunk);
  virtual void savePos(int pos) { m_savepos = pos; }
  virtual int getSavedPos() { return m_savepos; }
  virtual void setMainModuleName(const char *m);
  virtual const char *getMainModuleName();
  virtual void pushSet(const char *varid, int ispersistant);
  virtual void popSet();
  virtual int isInSet();
  virtual void addToVars(const char *txt);

private:
  PtrList < TemplateChunk > m_chunks;
  String m_format;
  String m_desc;
  int m_savepos;
  String m_mainModuleName;
  int m_setcount;
  Stack<VarSet*> m_setStack;
  TemplatizedFactory *m_parent;
};

#endif // __FACTORYTEMPLATE_H
