#include "precomp.h"
#include "ForEachAncestor.h"
#include "TemplatizedFactory.h"
#include "../classhierarchy/AncestorEnum.h"

#include <bfc/ptrlist.h>


ForEachAncestor::ForEachAncestor(TemplatizedFactory *parent, ClassFactoryChunk *chunk) : ForIterator(parent, FOREACH_ANCESTORS) {
  m_ae = NULL;

  m_chunk = chunk;
  if (m_chunk == NULL) {
    setNumIterations(0);
    return;
  }

  m_ae = new AncestorEnum(chunk, parent->getWorkspace());
  setNumIterations(m_ae->getNumAncestors());
}

ForEachAncestor::~ForEachAncestor() {
  delete m_ae;
}

AncestorEntry *ForEachAncestor::getAncestor(int n) {
  if (n == -1) n = getIterator();
  return m_ae->enumAncestor(n);
}

