#include "precomp.h"
#include "TemplatizedFactory.h"
#include "ForEachClass.h"
#include "ForEachProjectFolder.h"
#include "../classhierarchy/Project.h"
#include "../classhierarchy/Workspace.h"

#include <bfc/ptrlist.h>


ForEachClass::ForEachClass(TemplatizedFactory *parent) : ForIterator(parent, FOREACH_CLASS) {
  ForEachProjectFolder *fepf = parent->getForEachProjectFolder();

  int n = g_workspace->getNumChunks();
  int i;
  for (i=0;i<n;i++) {
    ClassFactoryChunk *chunk = g_workspace->enumChunk(i);
    if (fepf != NULL) {
      String folder = chunk->getParams()->getItemValue("project_folder");
      if (folder.getChar(0) != '/') folder = StringPrintf("/%s", folder.getValue());
      if (folder.lastChar() != '/') folder.cat("/");
      folder = StringPrintf("/root%s", folder.getValue());
      if (!STRCASEEQL(fepf->getFolder(), folder)) continue;
    }
    m_classes.addItem(chunk);
  }
  setNumIterations(m_classes.getNumItems());
}

ForEachClass::~ForEachClass() {
}

ClassFactoryChunk *ForEachClass::getClass(int n) {
  if (n == -1) n = getIterator();
  return m_classes.enumItem(n);
}
