#include "precomp.h"
#include "ForEachCodeBlock.h"
#include "../classhierarchy/ClassFactoryChunk.h"
#include "../classhierarchy/ClassFactoryCodeBlock.h"
#include "../classhierarchy/ClassFactoryBlock.h"

ForEachCodeBlock::ForEachCodeBlock(TemplatizedFactory *parent, ClassFactoryChunk *chunk, const char *type) : ForIterator(parent, FOREACH_CODEBLOCK) {
  m_chunk = chunk;
  m_type = type;
  m_numcodeblocks = 0;
  if (m_chunk != NULL) {
    int bn = m_chunk->getNumBlocks();
    int b;
    for (b = 0;b < bn; b++) {
      ClassFactoryBlock *block = m_chunk->enumBlock(b);
      if (block->getBlockType() == CF_BLOCKTYPE_CODEBLOCK) {
        ClassFactoryCodeBlock *cb = block->getCodeBlock();
        if (STRCASEEQLSAFE(cb->getType(), m_type))
          m_numcodeblocks++;
      }
    }
  }
  setNumIterations(m_numcodeblocks);
}

ForEachCodeBlock::~ForEachCodeBlock() {
}

ClassFactoryCodeBlock *ForEachCodeBlock::getCodeBlock(int n) {
  if (n == -1) n = getIterator();
  int curcodeblock = 0;
  int bn = m_chunk->getNumBlocks();
  int b;
  for (b = 0;b < bn; b++) {
    ClassFactoryBlock *block = m_chunk->enumBlock(b);
    if (block->getBlockType() == CF_BLOCKTYPE_CODEBLOCK) {
      ClassFactoryCodeBlock *cb = block->getCodeBlock();
      if (STRCASEEQLSAFE(cb->getType(), m_type)) {
        if (curcodeblock == n) return block->getCodeBlock();
        curcodeblock++;
      }
    }
  }
  return NULL;
}

int ForEachCodeBlock::getNumCodeBlocks() { 
  return m_numcodeblocks; 
}






