#include "precomp.h"
#include "ForEachData.h"
#include "../classhierarchy/ClassFactoryChunk.h"
#include "../classhierarchy/ClassFactoryData.h"
#include "../classhierarchy/ClassFactoryBlock.h"

ForEachData::ForEachData(TemplatizedFactory *parent, ClassFactoryChunk *chunk) : m_chunk(chunk), ForIterator(parent, FOREACH_DATA) {
  m_chunk = chunk;
  m_numdata= 0;
  if (m_chunk != NULL) {
    int bn = m_chunk->getNumBlocks();
    int b;
    for (b = 0;b < bn; b++) {
      ClassFactoryBlock *block = m_chunk->enumBlock(b);
      if (block->getBlockType() == CF_BLOCKTYPE_DATA) {
        m_numdata++;
      }
    }
  }
  setNumIterations(m_numdata);
}


ForEachData::~ForEachData() {
}

ClassFactoryData *ForEachData::getData(int n) {
  if (n == -1) n = getIterator();
  int curdata = 0;
  int bn = m_chunk->getNumBlocks();
  int b;
  for (b = 0;b < bn; b++) {
    ClassFactoryBlock *block = m_chunk->enumBlock(b);
    if (block->getBlockType() == CF_BLOCKTYPE_DATA) {
      if (curdata == n) return block->getData();
      curdata++;
    }
  }
  return NULL;
}

int ForEachData::getNumData() { 
  return m_numdata; 
}


