#include "precomp.h"
#include "ForEachHelperFile.h"
#include "../classhierarchy/HelperFileEnum.h"

#include <bfc/ptrlist.h>


ForEachHelperFile::ForEachHelperFile(TemplatizedFactory *parent, ClassFactoryChunk *chunk, int helpernum) : ForIterator(parent, FOREACH_HELPERFILES) {
  m_hfe = NULL;

  m_chunk = chunk;
  if (m_chunk == NULL) {
    setNumIterations(0);
    return;
  }

  m_hfe = new HelperFileEnum(chunk, helpernum);
  setNumIterations(m_hfe->getNumFiles());
}

ForEachHelperFile::~ForEachHelperFile() {
  delete m_hfe;
}

const char *ForEachHelperFile::getFile(int n) {
  if (n == -1) n = getIterator();
  return m_hfe->enumFile(n);
}


