#include "precomp.h"
#include "ForEachImplFile.h"
#include "../classhierarchy/ImplFileEnum.h"

#include <bfc/ptrlist.h>


ForEachImplFile::ForEachImplFile(TemplatizedFactory *parent, ClassFactoryChunk *chunk) : ForIterator(parent, FOREACH_IMPLFILES) {
  m_ife = NULL;

  m_chunk = chunk;
  if (m_chunk == NULL) {
    setNumIterations(0);
    return;
  }

  m_ife = new ImplFileEnum(chunk);
  setNumIterations(m_ife->getNumFiles());
}

ForEachImplFile::~ForEachImplFile() {
  delete m_ife;
}

const char *ForEachImplFile::getFile(int n) {
  if (n == -1) n = getIterator();
  return m_ife->enumFile(n);
}


