#ifndef __FOREACHMETHOD_H
#define __FOREACHMETHOD_H

#include "../classhierarchy/ClassFactoryMethodI.h"

#include "ForIterator.h"
#include <bfc/string/string.h>

/*<?<autoheader/>*/
class ClassFactoryChunk;
class ClassFactoryMethod;
class TemplatizedFactory;
/*?>*/

class ForEachMethod : public ForIterator {
public:
  ForEachMethod(TemplatizedFactory *parent, ClassFactoryChunk *chunk, const char *filter);
  virtual ~ForEachMethod();

  virtual ClassFactoryMethod *getMethod(int n = -1);
  virtual int getNumMethods();

  void filter(const char *filter);

private:
  ClassFactoryMethod *getMethod(ClassFactoryChunk *chunk, int curdepth, int curn, int n);
  void makeMethodList(ClassFactoryChunk *chunk, int curdepth);
  int overrides(ClassFactoryMethod *possibleancestor, ClassFactoryMethod *possibleoverride);

  ClassFactoryChunk * m_chunk;
  int m_maxdepth;
  String m_filter;
  TemplatizedFactory *m_parent;
  PtrListQuickMultiSorted<ClassFactoryMethod, ClassFactoryMethodSort> m_methods;
};

class ForEachRetiredMethod : public ForEachMethod {
  public:
    ForEachRetiredMethod(TemplatizedFactory *parent, ClassFactoryChunk *chunk, ClassFactoryMethod *m); 
};

#endif
