#ifndef __FOREACHPROJECTFOLDER_H
#define __FOREACHPROJECTFOLDER_H

#include "../outputfactories/ForIterator.h"
#include "../classhierarchy/ClassFactoryChunkI.h"
#include <bfc/ptrlist.h>
#include <bfc/string/string.h>

/*<?<autoheader/>*/
class TemplatizedFactory;
/*?>*/

// move to string.h
class SortString {
public:
  static int compareItem(String *p1, String *p2) {
    return STRICMP(p1->getValue(), p2->getValue());
  }
  static int compareAttrib(const char *attrib, String *item) {
    return STRICMP(attrib, item->getValue());
  }
};

class ForEachProjectFolder : public ForIterator {
public:
  ForEachProjectFolder(TemplatizedFactory *parent, const char *rootitem = NULL, int nextfolder = 0, int thisfolder = 0);
  virtual ~ForEachProjectFolder();

  virtual const char *getFolder(int n = -1);

private:
  PtrListInsertSorted < String, SortString > m_folders;
};

#endif // __FOREACHPROJECTFOLDER_H
