#include "precomp.h"
#include "ForIterator.h"

ForIterator::ForIterator(TemplatizedFactory *parent, int type) : m_parent(parent), m_type(type) {
  m_iterator = 0;
  m_numiterations = 0;
  m_looppos = 0;
}

ForIterator::~ForIterator() {
}

int ForIterator::getType() { 
  return m_type; 
}

int ForIterator::getIterator() { 
  return m_iterator; 
}

int ForIterator::getNumIterations() { 
  return m_numiterations; 
}

void ForIterator::inc() {
  m_iterator++; 
}

void ForIterator::dec() { 
  m_iterator--; 
  ASSERT(m_iterator != -1); 
}

void ForIterator::setLoopPos(int pos) { 
  m_looppos = pos; 
}

int ForIterator::getLoopPos() { 
  return m_looppos; 
}

int ForIterator::isFirst() { 
  return m_iterator == 0; 
}

int ForIterator::isLast() { 
  return m_iterator == m_numiterations-1; 
}

TemplatizedFactory *ForIterator::getParent() {
  return m_parent;
}

void ForIterator::setNumIterations(int n) { 
  m_numiterations = n; 
}

