#ifndef __FORITERATOR_H
#define __FORITERATOR_H

#include <bfc/assert.h>

/*<?<autoheader/>*/
class TemplatizedFactory;
/*?>*/

enum {
  FOREACH_METHOD=0,
  FOREACH_PARAM=1,
  FOREACH_CODEBLOCK=2,
  FOREACH_CLASS=3,
  FOREACH_ANCESTORS=4,
  FOREACH_IMPLFILES=5,
  FOREACH_HELPERS=6,
  FOREACH_HELPERFILES=7,
  FOREACH_PROJECTFOLDERS=8,
  FOREACH_DATA=9,
  FOREACH_TEMPLATEPARAM=10,
  FOREACH_GROUPDEFFOLDERS=11,
  FOREACH_PACKAGEDFILES=12,
  FOREACH_MAPENTRIES=13,
  FOREACH_USER=1000, // use 1000 and above for your own enumerators
};

class ForIterator {
public:
  ForIterator(TemplatizedFactory *parent, int type);
  virtual ~ForIterator();

  virtual int getType();
  virtual int getIterator();
  virtual int getNumIterations();
  virtual void inc();
  virtual void dec();
  virtual void setLoopPos(int pos);
  virtual int getLoopPos();

  virtual int isFirst();
  virtual int isLast();
  virtual TemplatizedFactory *getParent();

protected:
  void setNumIterations(int n);

private:
  int m_type;
  int m_iterator;
  int m_numiterations;
  int m_looppos;
  TemplatizedFactory * m_parent;
};

#endif
