#ifndef __GLOBALSTRINGS_IMPL_H
#define __GLOBALSTRINGS_IMPL_H

/*<?<autoheader/>*/
class GlobalString;
/*?>*/

#include "bfc/ptrlist.h"
#include "GlobalString.h"

class GlobalStrings {
public:
  GlobalStrings();
  virtual ~GlobalStrings();

  virtual const char *getString(const char *id);
  virtual void setString(const char *id, const char *val);
  virtual void removeString(const char *id);
  virtual GlobalString *getStringObject(const char *id);
  virtual int haveString(const char *id);

  virtual int getNumStrings() { return m_globalStrings.getNumItems(); }
  virtual const char *enumString(int n) { return m_globalStrings.enumItem(n)->getId(); }
  virtual const char *enumStringVal(int n) { return m_globalStrings.enumItem(n)->getValue(); }

  virtual void reset();

  PtrListInsertSorted < GlobalString, SortGlobalString > m_globalStrings;
};

extern GlobalStrings *g_globalVars;


#endif // __GLOBALSTRINGS_IMPL_H
