#ifndef __HELPER_H
#define __HELPER_H

#include "TemplatizedFactory.h"
#include "Helper.h"

#include <bfc/string/string.h>

/*<?<autoheader/>*/
class ClassFactoryChunk;
/*?>*/

// move to string.h
class HSortString {
public:
  static int compareItem(String *p1, String *p2) {
    return STRICMP(p1->getValue(), p2->getValue());
  }
  static int compareAttrib(const char *attrib, String *item) {
    return STRICMP(attrib, item->getValue());
  }
};

class Helper : public TemplatizedFactory {
public:
  Helper(const char *ext = "xpst");
  virtual ~Helper();

  virtual void onNewChunk(ClassFactoryChunk *chunk);
  virtual int getNumAvailableFormats();
  virtual const char *enumAvailableFormat(int i);
  virtual int tryFormat(const char *format);

private:
  PtrListQuickMultiSorted < String, HSortString > m_files;
  String m_format;
  String m_ext;
};


#endif // __HELPER_H
