#ifndef __IMPLEMENTATIONFACTORY_H
#define __IMPLEMENTATIONFACTORY_H

#include "OutputFactoryBase.h"
#include "TemplatizedFactory.h"
#include <bfc/string/bigstring.h>
#include "InlineXmlFactory.h"

/*<?<autoheader/>*/
class ChunkCollection;
class ClassFactoryChunk;
class ClassFactoryMethod;
class OutputFactoryBase;
class ProgressCallback;
/*?>*/

// -----------------------------------------------------------------------
class ImplementationFactory : public OutputFactoryBase {
public:
  ImplementationFactory();
  virtual ~ImplementationFactory();

  static const char *getServiceName() { return "Implementation Factory Service"; }
  virtual int tryFormat(const char *format);
  virtual const char *getName();
  virtual const char *getDescription();
  virtual int getNumModules();
  virtual const char *enumModuleName(int i);
  virtual const char *enumModuleData(int i);
  virtual void setChunk(ClassFactoryChunk *_chunk);
  virtual int process();
  virtual void setProgressCallback(ProgressCallback *cb);

  virtual int processImplementation(ClassFactoryChunk *chunk, PtrList < String > *additional_members);
  virtual int process_add_members(const char *format, PtrList < String > *members);

  static void writeImplementationMethod(int helper, ClassFactoryChunk *chunk, ClassFactoryMethod *m, String &str, OutputFactoryBase *base, const char *forcecallclass = NULL, Workspace *workspace = NULL, int bodyonly = 0);

private:
  ClassFactoryChunk * chunk;
  BigString str;
  String clstr;

  String headerName;
  String headerData;
  String moduleName;
  String moduleData;
  String ancestorName;
  String implclassname;
  String interfclassname;
  ProgressCallback * m_ppercent;
};

#endif
