#ifndef __INLINEXMLFACTORY_H
#define __INLINEXMLFACTORY_H

#include "FactoryModule.h"
#include "TemplatizedFactory.h"

#include <bfc/string/string.h>

/*<?<autoheader/>*/
class ClassFactoryChunk;
class ClassFactoryMethod;
class XmlReaderParams;
/*?>*/

class InlineXmlFactory : public TemplatizedFactory {
public:
  InlineXmlFactory();
  virtual ~InlineXmlFactory();

  virtual void setMethod(ClassFactoryMethod *method);
  virtual void setAncestor(const char *ancestor);
  virtual const char *getAncestor();
  virtual ClassFactoryMethod *getMethod();
  virtual void onCustomTag(const char *tag, XmlReaderParams *params, int isclose, int discard);
  virtual int getCustomSkip();
  virtual void setChunk(ClassFactoryChunk *chunk);
  virtual ClassFactoryMethod *getRootMethod() { return InlineXmlFactory::getMethod(); }

private:
  ClassFactoryMethod * m_method;
  String m_ancestor;
  int incallup;
  int innocallup;
  FactoryModule m_cpp;
  String tempString;
};

#endif // __INLINEXMLFACTORY_H
