#include "precomp.h"
#include "TypeMap.h"

void TypeMap::addMapping(const char *type, const char *mapping, const char *impl) {
  TypeMapEntry *entry = getMap(type);
  if (!entry) {
    entry = new TypeMapEntry(this, type, mapping, impl);
    m_entries.addItem(entry);
  } else entry->setMapping(mapping, impl);
}

const char *TypeMap::enumMappingFrom(int n) {
  TypeMapEntry *tme = m_entries.enumItem(n);
  if (!tme) return NULL;
  return tme->getType();
}

const char *TypeMap::enumMappingTo(int n) {
  TypeMapEntry *tme = m_entries.enumItem(n);
  if (!tme) return NULL;
  return tme->getMapping(0);
}

const char *TypeMap::enumMappingImpl(int n) {
  TypeMapEntry *tme = m_entries.enumItem(n);
  if (!tme) return NULL;
  return tme->getMapping(1);
}

void TypeMapEntry::setType(const char *type) {
  m_type = type;
  m_parent->resort();
}

