#ifndef __VFS_H
#define __VFS_H

#ifdef WIN32
#include <windows.h>
#endif

#include <stdio.h>

#define VFILE_INC 65536

#define VFS_READ				1
#define VFS_WRITE				2
#define VFS_SEEKEOF			4
#define VFS_CREATE			8
#define VFS_NEWCONTENT 16
#define VFS_MUSTEXIST  32

#ifndef _SIZE_T
#define _SIZE_T
typedef unsigned size_t;
#endif

class VFILE {
  public:
		unsigned char *data;
    unsigned long ptr;
    unsigned long filesize;
    unsigned long maxsize;
    char *filename;
    char mode;
		BOOL cached;
		FILE *rfile;
};

#ifdef __cplusplus
extern "C" {
#endif

VFILE *Vfopen(const char *fl, const char *mode, BOOL Cached);
VFILE *Vfopen_mem(const char *mem, const char *mode, int size);
VFILE *_Vfopen(const char *fl, const char *mode, BOOL Cached, const char *mem, int size);
void Vfread(void *ptr, size_t size, size_t n, VFILE *buf);
void Vfseek(VFILE *fl, long i, int whence);
unsigned long Vftell(VFILE *fl);
void Vfclose(VFILE *fl);
void Vfwrite(void *ptr, size_t size, size_t n, VFILE *f);
void Vfputs(char *str, VFILE *fl);
void Vgrow(VFILE *f);
void Vfputc(char c, VFILE *fl);
int Vfeof(VFILE *fl);
char *Vfgets(char *dest, int n, VFILE *fl);
char Vfgetc(VFILE *fl);
void Vsync(VFILE *fl);
const char *Vfgetmem();

#ifdef __cplusplus
}
#endif

#endif

