#ifndef __XHDFACTORY_H
#define __XHDFACTORY_H

// The helper class for svc_srcClassFactoryI
#include "OutputFactoryBase.h"

// -----------------------------------------------------------------------
// This header defines a new instance of the codegen service to output
// modules publishing a given class into the Xui and/or Script sections.
// -----------------------------------------------------------------------

class ClassFactoryChunk;
class ClassFactoryMethod;

// -----------------------------------------------------------------------
class XHDFactory : public OutputFactoryBase {
  public:
    XHDFactory() : chunk(NULL), m_ppercent(NULL) {};
    virtual ~XHDFactory() {};

    static const char *getServiceName() { return "XHD Class Factory Service"; }
    virtual int hasFormat(const char *format);
    virtual int getNumFormats();
    virtual const char *enumFormatName(int i);
    virtual int getNumModules();
    virtual const char *enumModuleName(int i);
    virtual const char *enumModuleData(int i);
    virtual void setChunk(ClassFactoryChunk *_chunk);
    virtual int process(const char *format);
    virtual void setProgressCallback(ProgressCallback *cb) { m_ppercent = cb; }

  protected:
    // This method sets up all the input strings and then tells all the output methods to run
    virtual int processXHD(ClassFactoryChunk *chunk);

  private:
    // Output Strings
    String xhdName;
    String xhdData;
    ClassFactoryChunk *chunk;
    ProgressCallback *m_ppercent;
};

#endif
