#ifndef __XHDWRITER_H
#define __XHDWRITER_H

#include <bfc/string/bigstring.h>
#include <bfc/ptrlist.h>

/*<?<autoheader/>*/
class ChunkCollection;
class ClassFactoryChunk;
class ProgressCallback;
class XmlReaderParams;
/*?>*/

class XHDWriter {
public:
  static const char *paramsToText(XmlReaderParams *p, const char *prfx=NULL, XmlReaderParams *raw_params=NULL);
  static const char *paramToText(const char *name, const char *value, String &dest, const char *prfx=NULL);
  static const char *convert(ClassFactoryChunk *c, const char *file =  NULL, ProgressCallback *percent =  NULL, ChunkCollection *collection =  NULL);
  static void fixupCData(String &str);

private:
  static BigString pttstr;
  static String xmlData;
  static ProgressCallback * m_ppercent;
  static ChunkCollection * m_chunkcollection;
};

#endif // __XHDWRITER_H
