#include "precomp.h"
#include "classhierarchy/Project.h"
#include "pworkspace.h"

CastMgr *g_casts = NULL;
TypeMapMgr *g_typeMaps = NULL;

PreprocWorkspace::PreprocWorkspace() {
  g_casts = &m_casts;
  g_typeMaps = &m_typeMaps;
}

PreprocWorkspace::~PreprocWorkspace() {
}

int PreprocWorkspace::getNumChunks(const char *project) {
  return chunks.getNumItems();
}

ClassFactoryChunk *PreprocWorkspace::enumChunk(int n, const char *project) {
  return chunks.enumItem(n);
}

ClassFactoryChunk *PreprocWorkspace::findChunk(const char *classname) {
  ClassFactoryChunk *c = chunks_by_implementation.findItem(classname);
  if (c) return c;
  c = chunks_by_interface.findItem(classname);
  return c;
}

void PreprocWorkspace::addChunk(ClassFactoryChunk *chunk) {
  chunks.addItem(chunk);
  chunks_by_implementation.addItem(chunk);
  chunks_by_interface.addItem(chunk);
}

const char *PreprocWorkspace::getTemplateDir() {
  return m_templatedir;
}

void PreprocWorkspace::setTemplateDir(const char *td) {
  m_templatedir = td;
  if (!m_templatedir.isempty())
    if (!Std::isDirChar(m_templatedir.lastChar())) m_templatedir.cat(DIRCHARSTR);
}
