#ifndef _PREPROCWORKSPACE_H
#define _PREPROCWORKSPACE_H

#include "classhierarchy/ClassFactoryChunkI.h"
#include "classhierarchy/Workspace.h"
#include "outputfactories/Cast.h"
#include <api/xml/xmlparamsi.h>
#include "outputfactories/TypeMap.h"

class PreprocWorkspace : public Workspace, public XmlReaderParamsI {
public:
  PreprocWorkspace();
  virtual ~PreprocWorkspace();
  virtual int getNumChunks(const char *project=NULL);
  virtual ClassFactoryChunk *enumChunk(int n, const char *project=NULL);
  virtual ClassFactoryChunk *findChunk(const char *classname);
  virtual void addChunk(ClassFactoryChunk *chunk);
  virtual XmlReaderParams *getParams() { return this; }
  virtual const char *getPrecompFile() { return m_precompfile; }
  void setPrecomFile(const char *pf) { m_precompfile = pf; }
  virtual const char *getTemplateDir();
  void setTemplateDir(const char *td);
private:
  PtrListQuickSorted<ClassFactoryChunk, ClassFactoryChunkSortImplementation> chunks_by_implementation;
  PtrListQuickSorted<ClassFactoryChunk, ClassFactoryChunkSortInterface> chunks_by_interface;
  PtrList<ClassFactoryChunk> chunks;
  CastMgr m_casts;
  TypeMapMgr m_typeMaps;
  String m_precompfile;
  String m_templatedir;
};

#endif

